# module Puma

encoding: utf-8

Conservative native JRuby/Java implementation of IOBuffer backed by a ByteArrayOutputStream and conversion between Ruby String and Java bytes

### Constants

HTTP_STATUS_CODES

  Every standard HTTP code mapped to the appropriate message. Generated with: curl -s www.iana.org/assignments/http-status-codes/http-status-codes-1.csv | \

      ruby -ne 'm = /^(\d{3}),(?!Unassigned|\(Unused\))([^,]+)/.match($_) and \
                puts "#{m[1]} => \x27#{m[2].strip}\x27,"'

IS_JRUBY
IS_WINDOWS
Plugins
STATUS_WITH_NO_ENTITY_BODY

  For some HTTP status codes the client only expects headers.

### Attributes

cli_config[RW]

The CLI exports its Puma::Configuration object here to allow apps to pick it up. An app needs to use it conditionally though since it is not set if the app is launched via another mechanism than the CLI class.

### Public Class Methods

jruby?() click to toggle source

    # File lib/puma/detect.rb, line 4
    def self.jruby?
      IS_JRUBY
    end

run(opts={}) { |c| ... } click to toggle source

    # File lib/puma/convenient.rb, line 5
    def self.run(opts={})
      cfg = Puma::Configuration.new do |user_config|
        if port = opts[:port]
          user_config.port port
        end

        user_config.quiet

        yield c
      end

      cfg.clamp

      events = Puma::Events.null

      launcher = Puma::Launcher.new cfg, :events => events
      launcher.run
    end

stats() click to toggle source

    # File lib/puma.rb, line 20
    def self.stats
      @get_stats.stats
    end

stats_object=(val) click to toggle source

    # File lib/puma.rb, line 16
    def self.stats_object=(val)
      @get_stats = val
    end

windows?() click to toggle source

    # File lib/puma/detect.rb, line 10
    def self.windows?
      IS_WINDOWS
    end